﻿#region Using directives

using System;
using System.Runtime.Remoting.Messaging;

#endregion

namespace MiMFa.Libraries.AOPLibrary
{
    [AOP]
    public class AOPBaseClass : ContextBoundObject
    {
        public AOPBaseClass() {}

        public virtual IMessage SyncProcessMessage(IMessageSink sink, IMessage msg)
        {
            AOPControllerInfo cinfo = AOPConfig.GetAssoc(GetType());
            if (cinfo != null && cinfo.controller != null)
            {
                if (cinfo.matcher.IsMatch(msg))
                    return cinfo.controller.SyncProcessMessage(this, sink, msg);
            }

            return sink.SyncProcessMessage(msg);
        }
    }
}
