﻿#region Using directives

using System.Runtime.Remoting.Contexts;
using System.Runtime.Remoting.Messaging;
using System.Diagnostics;

#endregion

namespace FrogSoftware.Libraries.AOPLibrary
{
    public class AOPProperty : IContextProperty, IContributeServerContextSink
    {
        public AOPProperty() {}

        public IMessageSink GetServerContextSink(IMessageSink nextSink)
        {
            IMessageSink logSink = new AOPSink(nextSink);
            return logSink;
        }

        public string Name {get {return "AOP";}}

        public bool IsNewContextOK(Context ctx)
        {
            AOPProperty newContextLogProperty = ctx.GetProperty("AOP") as AOPProperty;
            if (newContextLogProperty == null)
            {
                Debug.Assert(false);
                return false;
            }
            return (true);
        }

        public void Freeze(Context ctx) {}
    }
}
